# Export Wordpress Data with Advanced Filters

Contributors: smackcoders
Donate link: https://www.paypal.me/smackcoders
Tags: WordPress exporter, wp exporter, CSV, exporter, all export, export, csv export
Requires at least: 5.0
Tested up to: 6.0
Requires PHP: 5.2.4
Stable tag: 1.7.5
Version: 1.7.5
Author: smackcoders
Author URI: https://profiles.wordpress.org/smackcoders/
License: GPLv2 or later

WP Ultimate Exporter is an addon for ultimate csv importer plugin to download Post, Page and Custom Posts data as CSV.

## Description

WP Ultimate Exporter addon enables to export Post, Page and Custom Posts as CSV files. The various filter options are available to ease up the export process & to export only minimum precise data. The files are exported based on the filter settings opted by the user as per need. The filters enable to export the files imported by specific author, with specified delimiters and status in a specific period of time.

The WP Ultimate Exporter is an add-on of [WP Ultimate CSV Importer](https://wordpress.org/plugins/wp-ultimate-csv-importer/), so make sure you have it installed.

Please show your support for WP Ultimate Exporter by giving it a [rating](https://wordpress.org/support/view/plugin-reviews/wp-ultimate-exporter?rate=5#postform) :)

### Highlights

- Easy export in two simple steps.
- Post, Page and Custom Post CSV export
- Can export any custom fields along with post types
- WordPress Export with auto delimiters and forced quotes to avoid conflicts
- Export select set of data for a specific period of time using date filter
- Export data based on different post status
- Export post data by authors name filter

If you need a WordPress import & export tool, you can check on our [WP Ultimate CSV Importer](https://www.smackcoders.com/wp-ultimate-csv-importer-pro.html?utm_source=WpOrg&utm_medium=Readme&utm_campaign=ListingTraffic)

Click here to get [Ultimate Exporter Pro](https://www.smackcoders.com/ultimate-exporter.html)plugin

### Procedure

Step-1: Module Selection <br />

- Select the module to be exported. <br />
- Click on 'Proceed' to export. <br />

Step-2: Advanced Filters <br />

- To export the data based on filters, select export filters and specify the values. <br />
- Provide the filename and click 'Export', the exported file will be in CSV format.<br />

### Supported Modules To Export

- Core Module - Post, Page, Custom Post, Category, Tags, Users, Customer Reviews.
- eCommerce Products – WooCommerce, MarketPress, WP e-Commerce.
- SEO field - All in One SEO and Yoast SEO.
- Custom fields – Toolset Types, ACF, CMB2, CustomPress, Custom Fields Suite, Pods, CCTM.
- Custom Post – Types, CMB2, CustomPress, Pods, CPT UI, CCTM.

### Other Useful Plugins & Addons By Smackcoders

The Leads Builder for WordPress to capture your webforms as leads to one of the top ranking open source CRM, install the [WordPress Lead Form Data Collection to CRM](https://wordpress.org/plugins/wp-leads-builder-any-crm/) Plugin. Install one of the CRM of your choice with the additional add-ons listed below and keep both parent plugin and CRM addon activated.

- [Zoho CRM & Zoho CRM Plus](https://wordpress.org/plugins/wp-zoho-crm/)
- [Salesforce](https://wordpress.org/plugins/wp-salesforce/)
- [SugarCRM](https://wordpress.org/plugins/wp-sugar-free/)
- [Freshsales](https://wordpress.org/plugins/wp-freshsales/)
- [Vtiger CRM](https://wordpress.org/plugins/wp-tiger/)

To know more about the premium bundled version, visit [WordPress Lead Form Data Collection to CRM with unlimited features](https://www.smackcoders.com/wp-leads-builder-any-crm-pro.html)

### Helpful links

Try the demo [WP Ultimate CSV Importer PRO](https://demo.smackcoders.com/wordpress/wp-admin/admin.php?page=sm-uci-dashboard) plugin to import all WooCommerce products along with WooCommerce add-ons.

For technical support and feature request, visit <a href="https://www.smackcoders.com/support.html?utm_source=wordpress&utm_medium=readme&utm_campaign=free_exporter"> Smackcoders support </a>.

Read the blog to know about our [latest WordPress add-on](https://www.smackcoders.com/blog.html?utm_source=wordpress&utm_medium=readme&utm_campaign=free_exporter) updates.

## Installation

1. First, install [CSV Importer](https://wordpress.org/plugins/wp-ultimate-csv-importer/) and then install the Exporter.
2. Extract the wp-ultimate-exporter.zip in wordpress/wp-content/plugins using FTP or through plugin install in wp-admin.
3. Activate the plugin in the WordPress plugin list.

## Screenshots

1. Module selection view of WP Ultimate Exporter.
2. Export with specific delimiters.
3. Export data uploaded in a specific period of time.
4. Status based CSV export.
5. Export files published by a particular author
6. Export only selected fields of any Post type.

## Frequently Asked Questions

### 1. Can we export Custom Post created with any third party plugin?

Yes, you can export all Custom Post listed in the drop down.

### 2. Is there any limitation on the number exports exported?

No, there is no limitation on the records exported.

## Changelog
### 1.7.2

- Checked: Compatibility for WordPress 5.9.3
- Added: Export Support for WP Job Manager Plugin.

### 1.7.1

- Checked: Compatibility for WordPress 5.9

### 1.7 
* Added: Export support for latest LearnPress-LMS plugin-V4.1.4.1:Courses,Lessons,Quizzes,Orders and Questions. 

### 1.6.3
- Added: Export support for latest woocommerce product bundle plugin fields 

### 1.6.2

- Checked: Compatibility for WordPress 5.8

### 1.6.1

- Added: Compatibility for WordPress 5.7.2
- Added: Export support for Polylang & Polylang for WooCommerce plugin.

### 1.6

- Added: Compatibility for WordPress 5.7.1
- Added: Compatibility for All in One SEO latest version 4.1.0.2

### 1.5.9

- Fixed: CPT Export

### 1.5.8

- Added: WordPress 5.6 compatibility
- Added: PHP 8 compatibility

### 1.5.7

- Added: Extended Export support for WooCommerce Product Bundle Fields.

### 1.5.6

- Added: Compatibility for WordPress 5.5.1
- Added: Export support for Variation Swatcher for WooCommerce Plugin.

### 1.5.5

- Export support for WC Product Bundle Meta Fields.

### 1.5.4

- Added: Export support for specific Widget Values(Posts,Pages,Comments,Categories and Archives).

### 1.5.3

- Added: Export support for BBPress Plugin(forum,topic and reply).
- Added: Navigation Menu Export.

### 1.5.2

- Added: WP CSRF Protection

### 1.5.1

- Added: Export support for Learnpress-LMS Plugin(Courses,Lessons,Quizzes,Orders and Curriculum).

### 1.5

- Added: Support for comment reply field

### 1.4.9

- Fixed: Post Category hierarchical export issue

### 1.4.8

- Checked: Compatibility for WordPress 5.3.2

### 1.4.7

- Fixed: Custom Post Export Issue

### 1.4.6

- Fixed: CPT-UI with product category export issue
- Fixed: Minor issues and warnings

### 1.4.5

- Added: new api call to find plugin installed or not
- Added: notice/alert for plugin not installed.

=1.4.4

- Added: Display total number of records to be exported
- Added: Progress bar and time indicator for export.
- Fixed: WooCommerce attribute export
- Fixed: Custom post export

=1.4.3

- Added: Compatibility for WordPress 5.0.3
- Fixed: Permission issue with the file export.

### 1.4.2

- Added: WP CSRF Protection

### 1.4.1

- Added: Compatibility for WordPress 5.0
- Fixed: Tags Export

### 1.4

- Added extra modules for export
- Fixed: Quoted fields export

### 1.3

- Added: Selective field based export.
- Modified: User Interface.

### 1.2

- Added: WordPress 4.6 compatibility.

### 1.1

- Fixed: Comma separated vulnerabilities.

### 1.0

- Initial release version. Tested and found to work well without any issues.

## Upgrade Notice
### 1.7.2

- Upgrade now for newly added features.
### 1.7.1

- Upgrade now for newly added features.

### 1.7

- Upgrade now for newly added features.

### 1.6.3

- Upgrade now for newly added features.

### 1.6.2

- Upgrade now for newly added features.

### 1.6.1

- Upgrade now for newly added features.

### 1.6

- Upgrade now for newly added features.

### 1.5.9

- Upgrade now for newly added features.

### 1.5.8

- Upgrade now for newly added features.

### 1.5.7

- Upgrade now for newly added features.

### 1.5.6

- Upgrade now for newly added features.

### 1.5.5

- Upgrade now for newly added features.

### 1.5.4

- Upgrade now for newly added features.

### 1.5.3

- Upgrade now for newly added features.

### 1.5.2

- Upgrade now for newly added features.

### 1.5.1

- Upgrade now for newly added features.

### 1.5

- Upgrade now for latest updates.

### 1.4.9

- Upgrade now for minor changes

### 1.4.8

- Upgrade now for WordPress 5.3.2 compatibility

### 1.4.7

- Upgrade now for custom post issue fix

### 1.4.6

- Upgrade now for improvements

### 1.4.5

- Upgrade now for minor changes

### 1.4.4

- Upgrade now latest version changes

### 1.4.3

- Upgrade now for permission issue fix and compatibility for WordPress 5.0.3

### 1.4.2

- Important update for security fixes.

=1.4.1=

- Upgrade now for tags export and WordPress 5.0 compatibility.

### 1.4

- Update now to get enhanced UI and compatible for WordPress 4.8.1.

### 1.3

- Update now to get enhanced UI and extended selective field export option.

### 1.2

- Upgrade now to get compatible with WordPress 4.6.

### 1.1

- Upgrade now for security fix.

### 1.0

- Initial stable release version.
